routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
/* YUNG DATI for education purposes
Route::get('/', function () {
    $name = 'Alex';
    return view('names.show-names') //yung folder'names.show-names', period ginagamit instead of slash
    ->with('name',['Alex','Ben','Sylvan']); 

});
*/

Route::get('/', function () {
    return view('welcome');


});

Route::delete('/carts/empty', 'CartController@empty')->name('carts.empty');

Route::post('/transactions/paypal','TransactionController@create_paypal_payment')->name('transactions.paypal');

Route::resource('categories','CategoryController');
Route::resource('products', 'ProductController');
Route::resource('carts', 'CartController');
Route::resource('transactions','TransactionController');


//to view create page

/*
Route::get('/categories/create','CategoryController@create')->name('categories.create');

Route::get('/categories', 'CategoryController@index')->name('categories.index');

Route::get('/categories/{category}','CategoryController@show')->name('categories.show');

Route::get('/categories/{category}/edit','CategoryController@edit')->name('categories.edit');

Route::post('/categories','CategoryController@store')->name('categories.store');

Route::put('/categories/{category}','CategoryController@update')->name('categories.update');

Route::delete('/categories/{category}','CategoryController@destroy')->name('categories.destroy');
*/
Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

app/Product.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Product extends Model
{
    public function category() {
    	return $this->belongsTo('App\Category');
    }
}

app/Http/Controllers/ProductController.php
<?php

namespace App\Http\Controllers;

use App\Product;
use App\Category;
use Illuminate\Http\Request;

class ProductController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
       $filter = $request->query('category');
    // dd($filter);
        if ($filter) {
           $products = Product::all()->whereIn('category_id', $filter);
        } else {
            $products = Product::all();
        }


      
        return view('products.index')->with('products',$products)->with('categories', Category::all());
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(Product $product)
    {
        
        $this->authorize('create', $product);

        $categories = Category::all();
        // dd($categories);
        return view('products.create')->with('categories',$categories);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request, Product $product)
    {
        //dd($request->file('image')); LONG CUT
        //dd($request->image); //SHORTCUT
        $this->authorize('create', $product);
        $request->validate([
                    'name' => 'required|string',
                    'price' => 'required|numeric',
                    'category-id' => 'required',
                    'description' => 'required|string',
                    'image' => 'required|image|max:5000'
                    ]);

        $product = new Product;
        $product->name = $request->input('name');
        $product->price = $request->input('price');
        $product->category_id = $request->input('category-id');
        $product->description = $request->input('description');

        $product->image = $request->image->store('products');
        $product->save();

        return redirect( route('products.index'));
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function show(Product $product)
    {
       return view('products.show')->with('product', $product);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function edit(Product $product)
    {
      $this->authorize('create', $product);
      $categories = Category::all();
      return view('products.edit')->with('product',$product)->with('categories',$categories);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Product $product)
    {
       $this->authorize('create', $product);
       $request->validate([
                    'name' => 'required|string',
                    'price' => 'required|numeric',
                    'category-id' => 'required',
                    'description' => 'required|string',
                    'image' => 'image|max:5000'
                    ]);

        
        $product->name = $request->input('name');
        $product->price = $request->input('price');
        $product->category_id = $request->input('category-id');
        $product->description = $request->input('description');

        if($request->hasFile('image')) {
          $product->image = $request->image->store('products');
        } 

        

        
        $product->save();

        $request->session()->flash('status','Update successful');

        return redirect( route('products.edit',['product'=>$product->id]));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function destroy(Product $product)
    {
        $this->authorize('create', $product);
        $product->delete();
        return redirect( route('products.index'))->with('status','Product is deleted.');
    }
}

resources/views/products/create.blade.php
@extends('layouts.app')

@section('content')

	<div class="container">
		<div class="row">
			<div class="col-12 col-md-8 mx-auto">
				<h3>Create Product Form</h3>
				<hr>
				<form class="form-group" action="{{ route('products.store')}}" method="POST" enctype="multipart/form-data">
					@csrf

					@if($errors->has('name'))
						<div class="alert alert-danger">
							{{$errors->first('name')}}
						</div>
					@endif

					<input type="text" name="name" id="name" class="form-control mb-2" placeholder="product name here" value="{{ old('name')}}">

					@if($errors->has('price'))
						<div class="alert alert-danger">
							{{$errors->first('price')}}
						</div>
					@endif

					<input type="text" name="price" id="price" class="form-control mb-2" placeholder="product price" value="{{ old('price')}}">
					
					

					<select name="category-id" id="category-id" class="custom-select">
						@foreach($categories as $category)
							<option
								value="{{$category->id}}"
								{{ old('category-id') == $category->id ? "selected" : ""}}
								>
								{{$category->name}}
							</option>
						@endforeach	
					</select>
					
					@if($errors->has('image'))
						<div class="alert alert-danger">
							{{$errors->first('image')}}
						</div>
					@endif

					<input type="file" name="image" id="image" class="form-control-file mb-2">
					
					@if($errors->has('description'))
						<div class="alert alert-danger">
							{{$errors->first('description')}}
						</div>
					@endif

					<textarea name="description" id="description" cols="10" rows="10" class="form-control mb-2" placeholder="product description">{{ old('description')}}</textarea>

					<button type="submit" class="btn btn-danger mb-2 mx-auto">Create New Product</button>
				</form>
			</div>
		</div>
	</div>
							
@endsection

resources/views/products/edit.blade.php
@extends('layouts.app')

@section('content')

	<div class="container">
		<div class="row">

			<div class="col-12 col-md-8 mx-auto">
				<h3>Edit Product Form</h3>
				<hr>

					@if(Session::has('status')) 
						<div class="alert alert-success">
							{{Session::get('status')}}
						</div>

					@endif



				<form class="form-group" action="{{ route('products.update', ['product'=> $product->id])}}" method="POST" enctype="multipart/form-data">
					@csrf
					@method('PUT')

					@if($errors->has('name'))
						<div class="alert alert-danger">
							{{$errors->first('name')}}
						</div>
					@endif

					<input type="text" name="name" id="name" class="form-control mb-2" placeholder="product name here" value="{{ $product->name}}">

					@if($errors->has('price'))
						<div class="alert alert-danger">
							{{$errors->first('price')}}
						</div>
					@endif

					<input type="text" name="price" id="price" class="form-control mb-2" placeholder="product price" value="{{$product->price}}">
					
					

					<select name="category-id" id="category-id" class="custom-select">
						@foreach($categories as $category)
							<option
								value="{{$category->id}}"
								{{ $product->category_id == $category->id ? "selected" : ""}}
								>
								{{$category->name}}
							</option>
						@endforeach	
					</select>
					
					@if($errors->has('image'))
						<div class="alert alert-danger">
							{{$errors->first('image')}}
						</div>
					@endif

					<input type="file" name="image" id="image" class="form-control-file mb-2">
					
					@if($errors->has('description'))
						<div class="alert alert-danger">
							{{$errors->first('description')}}
						</div>
					@endif

					<textarea name="description" id="description" cols="10" rows="10" class="form-control mb-2" placeholder="product description">{{ $product->description}}</textarea>

					<button type="submit" class="btn btn-danger mb-2 mx-auto">Edit Product</button>
				</form>
			</div>

			<div class="col-12 col-md-4 mx-auto">
			@include('products.includes.product-card')</div>

		</div>
	</div>
							
@endsection

resources/views/products/index.blade.php
@extends('layouts.app')

@section('content')

<div class="container">
	<div class="row">
		<div class="col-12">
			<form action="" method="get">
				
				<div class="row">
					<div class="col">
						<select name="category" id="category" class="form-control">
							<option value="">All</option>
							@foreach($categories as $category)
							<option value="{{$category->id}}">{{$category->name}}</option>
							@endforeach
						</select>
					</div>
					<div class="col">
				<button class="btn btn-outline-primary">
					Filter
				</button>
						
					</div>
				</div>
				
			</form>
		</div>
	</div>
	@if(Session::has('status'))
		<div class="alert alert-success">
			{{Session::get('status')}}
		</div>

	@endif
	@include('products.includes.error-status')
	<div class="row">


	@foreach($products as $product)
		{{-- START OF CARDS --}}
		<div class="col-12 col-md-4 col-lg-3 pb-3">
			@include('products.includes.product-card')
		</div>
		{{-- END OF CARD --}}
	@endforeach
	</div>
</div>

@endsection

resources/views/products/show.blade.php
@extends('layouts.app')

@section('content')

<div class="col-12 px-3 text-right"><h4><a href="{{ route('products.index')}}">Back to Products</a></h4>
	</div>

@include('products.includes.error-status')

{{-- START OF CARDS --}}
		<div class="col-12 col-md-4 col-lg-3 pb-3">
			@include('products.includes.product-card')
		</div>
		{{-- END OF CARD --}}



@endsection